REM speedtab.bas - a Qbasic program to generate a half wpm table for
REM the Morse Code Speedometer program - speedf84.asm
REM  The table is output to a file in a format which can be inserted or
REM     included into the speedometer PIC program.
REM  Table is 16 bit - 2 x 99 entries from .5 wpm to 99.5 wpm
REM
REM  1/15/2000  Chuck Olson, WB9KZY
REM             Jackson Harbor Press
REM             http://jacksonharbor.home.att.net/
REM             jacksonharbor@att.net
REM
    INPUT "Enter halfwpm table output filename: "; n$
    OPEN n$ FOR OUTPUT AS #1
REM This is a 99 entry table - 2 words per entry - 0.5 to 99.5 wpm
FOR i = 0 TO 99
REM Calculate the dit interval in tenths of a millisecond
z = 1.2 / (i + .5) * 10000
REM Round and integerize the interval
y = CINT(z)
REM Split the interval into two table entries
REM first, x calculates the upper byte by calculating 256 chunks in the interval
x = INT(y / 256)
REM second, w subtracts the upper byte * 256 from the interval to get the
REM  lower byte
w = y - (256 * x)
REM "print" the results to a file in the retlw table format.
REM     retlw is a return from a subroutine call with the value specified
REM     in the w register.
    PRINT #1, "        retlw   d'"; x; "'   ;"; i + .5; "wpm    "; CINT(z); "x .1 ms"
    PRINT #1, "        retlw   d'"; w; "'"
NEXT i
CLOSE


